#include <stdlib.h>
#include "CChromosome.h"

float g_MutationProbability = 0.01;

void CChromosome::CrossOver( CChromosome &Other, CChromosome *pOutput, int nChildren )
{
	if( !nChildren ) return;
	if( m_nGenes != Other.m_nGenes) {
		printf("PANIC\n");
		WriteInfo();
		Other.WriteInfo();
		return;
	}

	int r = rand() % m_nGenes;
	
	if(m_nGenes != pOutput[0].m_nGenes ) 
		pOutput[0].SetSize( m_nGenes );

	if( nChildren > 1 ){
		if(m_nGenes != pOutput[1].m_nGenes ) 
			pOutput[1].SetSize( m_nGenes );
	}


	int i;
	for(i=0;i<=r;++i){
		pOutput[0].m_pGenes[i] = m_pGenes[i];
		
		if(nChildren>1){
			pOutput[1].m_pGenes[i] = Other.m_pGenes[i];
		}
	}

	for(;i<m_nGenes;++i){
		pOutput[0].m_pGenes[i] = Other.m_pGenes[i];

		if(nChildren>1){
			pOutput[1].m_pGenes[i] = m_pGenes[i];
		}
	}
	
	if( !pOutput[0].m_nGenes ){
		printf("Erroneous Gene Found\n");
	}

	if(nChildren > 1 ){
		if( !pOutput[0].m_nGenes ){
			printf("Erroneous Gene Found\n");
		}
	}
}

bool CChromosome::Mutate( int SeqMin, int SeqMax, float XPosMin, float XPosMax )
{
	float r = (float)(rand() % 1000);
	
	if( r <= (1000.0f * g_MutationProbability) ){
		
		int Which = rand() % 100;
		int Idx   = rand() % m_nGenes;

		if( Which < 50 ){
			m_pGenes[Idx].m_Seq = (rand() % (SeqMax - SeqMin + 1)) + SeqMin;
		}
		else{
			//m_pGenes[Idx].m_XPos = (rand() % (int)(XPosMax - XPosMin + 1)) + XPosMin;
			float d = (float)(XPosMax - XPosMin);
			m_pGenes[Idx].m_XPos += ((float)(rand())/(float)RAND_MAX) * d - d/2.0f;
		}

		return true;
	}

	return false;
}