#include "CPolyDisplay.h"

int g_OpenGLAttribList[] = {
	WX_GL_RGBA,		
	WX_GL_DOUBLEBUFFER,
	WX_GL_MIN_RED,1,
	WX_GL_MIN_GREEN,1,
	WX_GL_MIN_BLUE,1,
	WX_GL_DEPTH_SIZE,0,
	0
};


SPolyOptions g_PolyOptions = {0};

BEGIN_EVENT_TABLE( CPolyDisplay, wxGLCanvas)
	EVT_PAINT( CPolyDisplay::OnPaint)
	EVT_ERASE_BACKGROUND( CPolyDisplay::OnEraseBackground )
	EVT_RIGHT_DOWN( CPolyDisplay::OnRightDown )
	EVT_MENU(XRCID("ID_RENDER_DRAW_BOUNDING_BOX"),CPolyDisplay::OnMenuDrawBoundingBox)
	EVT_MENU(XRCID("ID_RENDER_DRAW_FRONT_POINTS"),CPolyDisplay::OnMenuDrawFrontPoints)
	EVT_MENU(XRCID("ID_RENDER_DRAW_BACK_POINTS"),CPolyDisplay::OnMenuDrawBackPoints)	
	EVT_MENU(XRCID("ID_RENDER_DRAW_REFERENCE"),CPolyDisplay::OnMenuDrawReferencePoints)		
	EVT_MENU(XRCID("ID_RENDER_DRAW_SEQ_NUMBER"),CPolyDisplay::OnMenuDrawSeqNumber)
	EVT_MENU(XRCID("ID_RENDER_DRAW_FRONT_LINES"),CPolyDisplay::OnMenuDrawFrontLines)
	EVT_MENU(XRCID("ID_RENDER_DRAW_BACK_LINES"),CPolyDisplay::OnMenuDrawBackLines)
END_EVENT_TABLE();

BEGIN_EVENT_TABLE( CPlotter, wxGLCanvas)
	EVT_PAINT( CPlotter::OnPaint)
	EVT_ERASE_BACKGROUND( CPlotter::OnEraseBackground )
END_EVENT_TABLE();

FTGLPixmapFont	 CPlotter::m_Font("arial.ttf");
bool			 CPlotter::m_bFirst = true;
float			 CPlotter::m_LeftMargin = 10;
float			 CPlotter::m_RightMargin = 10;
float			 CPlotter::m_BottomMargin = 10;
float			 CPlotter::m_TopMargin = 2;

void CPolyDisplay::AddPolygon( CPolygon &Poly )
{
	SPolyItem p;
	p.m_Polygon = Poly;
	p.m_Polygon.m_Pos = p.m_Polygon.m_Pos + mgVector3(LEFT_MARGIN,BOTTOM_MARGIN,0);
	p.m_Seq = (int)m_PolyList.size();
	m_PolyList.push_back( p );
	float y = Poly.m_BoundingBox.m_MaxPoint.m_v[Y] + Poly.m_Pos.m_v[Y];
	if( m_MaxY < y ) m_MaxY = y;
}

void CPolyDisplay::DrawPolygon( SPolyItem &PolyItem )
{
	CPolygon& Poly = PolyItem.m_Polygon;

	
	glColor3f(0.6,0.6,0.6);
	glBegin(GL_LINE_LOOP);
	{
		for(size_t n=0;n<Poly.m_PointList.size();++n){
		
			mgVector3 v = Poly.m_PointList[n].m_Point + Poly.m_Pos;
			glVertex3fv( v.m_v );
		}
	}
	glEnd();	

	if( g_PolyOptions.m_bDrawAnchorPoint ){	
		glColor3f(0,0,0);
		glPointSize(5);
		glBegin(GL_POINTS);
			glVertex3fv(Poly.m_Pos.m_v);
		glEnd();
		glPointSize(1);
	}

	
	if( g_PolyOptions.m_bDrawFrontLines ){

		glLineWidth(2);
		glColor3f(1,0,0);
	
		glBegin(GL_LINES);
		{
			for(size_t n=0;n<Poly.m_FrontFacingLines.size();++n){
		
				mgVector3 vFrom = Poly.m_PointList[ Poly.m_FrontFacingLines[n].m_FromPointIdx ].m_Point;
				mgVector3 vTo   = Poly.m_PointList[ Poly.m_FrontFacingLines[n].m_ToPointIdx ].m_Point;;

				vFrom = vFrom + Poly.m_Pos;
				vTo   = vTo   + Poly.m_Pos;

				glVertex3fv( vFrom.m_v );
				glVertex3fv( vTo.m_v );

				
			}

		}
		glEnd();
		glLineWidth(1);
	}
	
	if( g_PolyOptions.m_bDrawBackLines ){

		glLineWidth(2);
		glColor3f(0,0,1);
	
		glBegin(GL_LINES);
		{
			for(size_t n=0;n<Poly.m_BackFacingLines.size();++n){
		
				mgVector3 vFrom = Poly.m_PointList[ Poly.m_BackFacingLines[n].m_FromPointIdx ].m_Point;
				mgVector3 vTo   = Poly.m_PointList[ Poly.m_BackFacingLines[n].m_ToPointIdx ].m_Point;;

				vFrom = vFrom + Poly.m_Pos;
				vTo   = vTo   + Poly.m_Pos;

				glVertex3fv( vFrom.m_v );
				glVertex3fv( vTo.m_v );

				
			}

		}
		glEnd();
		glLineWidth(1);
	}

	if(g_PolyOptions.m_bDrawFrontPoints){
		glColor3f(1,0,0);
		glPointSize(5);
		glBegin(GL_POINTS);
		{
			for(size_t n=0;n<Poly.m_FrontFacingCollidablePoints.size();++n){
				
				mgVector3 v = Poly.m_FrontFacingCollidablePoints[n].m_Point + Poly.m_Pos;
				
				glVertex3fv( v.m_v );
			}
		}
		glEnd();
		glPointSize(1);
	}

	if(g_PolyOptions.m_bDrawBackPoints){
		glColor3f(0,0,1);
		glPointSize(5);
		glBegin(GL_POINTS);
		{
			for(size_t n=0;n<Poly.m_BackFacingCollidablePoints.size();++n){
				
				mgVector3 v = Poly.m_BackFacingCollidablePoints[n].m_Point + Poly.m_Pos;
				
				glVertex3fv( v.m_v );
			}
		}
		glEnd();
		glPointSize(1);
	}

	if( g_PolyOptions.m_bDrawBoundingBox){
		glColor3f(1,0,0);

		glBegin(GL_LINE_LOOP);
		{
			mgVector3 v = Poly.m_BoundingBox.m_MinPoint + Poly.m_Pos;
			
			glVertex3fv( v.m_v );

			v = mgVector3(Poly.m_BoundingBox.m_MaxPoint.m_v[X],
						  Poly.m_BoundingBox.m_MinPoint.m_v[Y],
						  0)
				+ Poly.m_Pos;

			glVertex3fv( v.m_v );

			v = Poly.m_BoundingBox.m_MaxPoint + Poly.m_Pos;

			glVertex3fv( v.m_v );

			v = mgVector3(Poly.m_BoundingBox.m_MinPoint.m_v[X],
						  Poly.m_BoundingBox.m_MaxPoint.m_v[Y],
						  0)
				+ Poly.m_Pos;

			glVertex3fv( v.m_v );
		}
		glEnd();
	}

	if( g_PolyOptions.m_bDrawSeq ){
		char str[100];
		glColor3f(0,0,0);
		sprintf(str,"%d",PolyItem.m_Seq);
		glRasterPos2f(Poly.m_Pos.m_v[X]+10,Poly.m_Pos.m_v[Y]-10);		
		m_Font.Render( str );
	};
	
}

void CPolyDisplay::DrawAxes( )
{
	glColor3f(0,0,0);
	glBegin(GL_LINES);
		glVertex3f(LEFT_MARGIN,0,0);
		glVertex3f(LEFT_MARGIN,m_LogicalHeight,0);

		glVertex3f(m_LogicalWidth - LEFT_MARGIN,0,0);
		glVertex3f(m_LogicalWidth - LEFT_MARGIN,m_LogicalHeight,0);

		glVertex3f(0,BOTTOM_MARGIN,0);
		glVertex3f(m_LogicalWidth,BOTTOM_MARGIN,0);
	glEnd();

	float xGap = m_Width / 8.0f;
	float yGap = m_Height / 10.0f;

	float xCount = 0;
	float yCount = 0;

	glColor3f(0,0,0);
	for(int i=0;i<=8;i++){
		glRasterPos2f(LEFT_MARGIN+xCount,BOTTOM_MARGIN-14);
		m_Font.Render( wxString::Format(_T("%1.1f"),xCount).c_str() );		
		xCount += xGap;
	}

	xCount = 0;
	glBegin(GL_LINES);
	for(int i=0;i<=8;i++){
		glVertex2f(LEFT_MARGIN+xCount,BOTTOM_MARGIN+5);		
		glVertex2f(LEFT_MARGIN+xCount,BOTTOM_MARGIN-5);
		xCount += xGap;
	}
	glEnd();


	for(int i=0;i<=10;i++){
		glRasterPos2f(LEFT_MARGIN-40,BOTTOM_MARGIN+yCount+4);
		m_Font.Render( wxString::Format(_T("%1.1f"),yCount).c_str() );
		yCount += yGap;
	}

	yCount = 0;
	glBegin(GL_LINES);
	for(int i=0;i<=10;i++){
		glVertex2f(LEFT_MARGIN-5,BOTTOM_MARGIN+yCount);
		glVertex2f(LEFT_MARGIN+5,BOTTOM_MARGIN+yCount);
		yCount += yGap;
	}
	glEnd();
}

void CPolyDisplay::OnPaint( wxPaintEvent &e )
{
	wxPaintDC dc(this);
	SetCurrent();

	glClear(GL_COLOR_BUFFER_BIT);
	glLoadIdentity();
	
	for(size_t i=0;i<m_PolyList.size();++i){	
		DrawPolygon(m_PolyList[i]);		
	}

	glPointSize(10);
	glColor3f(0,0,0);
	glBegin(GL_POINTS);
	for(size_t i=0;i<m_DebugPointList.size();++i){
		float x = m_DebugPointList[i].m_v[X];
		float y = m_DebugPointList[i].m_v[Y];
		glVertex3fv( m_DebugPointList[i].m_v);
	}
	glEnd();
	glPointSize(1);

	DrawAxes();

	glBegin(GL_LINES);
		glVertex2f(LEFT_MARGIN,m_MaxY+BOTTOM_MARGIN);
		glVertex2f(m_LogicalWidth - LEFT_MARGIN,m_MaxY+BOTTOM_MARGIN);
	glEnd();

	glRasterPos2f(m_LogicalWidth/2.0f,m_MaxY+BOTTOM_MARGIN+10);
	m_Font.Render( wxString::Format(_T("Minimum Height = %0.2f"),m_MaxY).c_str() );

	SwapBuffers();
}

void CPolyDisplay::OnRightDown( wxMouseEvent &e )
{
	if( m_pRenderMenu ){
		PopupMenu( m_pRenderMenu, e.GetPosition() );
	}
}

CPlotter::CPlotter(wxWindow *pParent) :
	wxGLCanvas( pParent, wxID_ANY, wxPoint(0,0), wxSize(150,80),0,_T("GLCanvas"),
		g_OpenGLAttribList)
	{
		m_TopY = 50;
		m_MaxY = 0;
		m_MinY = 0;
		//m_LogicalWidth = 0;
		//m_LogicalHeight = 0;
	}

void CPlotter::OnPaint( wxPaintEvent &e )
{
	wxPaintDC dc(this);

	SetCurrent();

	glClear(GL_COLOR_BUFFER_BIT);

	glColor3f(0,0,0);
	glBegin(GL_LINES);
		glVertex2f(0,m_BottomMargin);
		glVertex2f(m_Width,m_BottomMargin);		
		
		glVertex2f(m_RightMargin,0);
		glVertex2f(m_RightMargin,m_Height);
		
		glVertex2f(0,m_Height- m_TopMargin);
		glVertex2f(m_Width,m_Height - m_TopMargin);
		
		glVertex2f(m_Width-m_RightMargin,0);
		glVertex2f(m_Width-m_RightMargin,m_Height);
	glEnd();

	glBegin(GL_LINE_STRIP);
	for(size_t i=0;i<m_PointList.size();++i){
		glVertex2f( m_PointList[i].m_v[X]*m_XStep+m_RightMargin,(m_PointList[i].m_v[Y]-m_MinY)*m_YStep+m_BottomMargin);
	}
	glEnd();

	glPointSize(2);
	glBegin(GL_POINTS);
	for(size_t i=0;i<m_PointList.size();++i){
		glVertex2f( m_PointList[i].m_v[X]*m_XStep+m_RightMargin,(m_PointList[i].m_v[Y]-m_MinY)*m_YStep+m_BottomMargin);
	}
	glEnd();
	glPointSize(1);

	glRasterPos2f(m_RightMargin-8,m_BottomMargin);
	m_Font.Render( wxString::Format(_T("%0.1f"),m_MinY).c_str() );

	glRasterPos2f(m_RightMargin-8,(m_TopY-m_MinY)*m_YStep+m_BottomMargin-8);
	m_Font.Render( wxString::Format(_T("%0.1f"),m_TopY).c_str() );

	SwapBuffers();
}
