#ifndef __CSTAT_H__
#define __CSTAT_H__

#include <stdio.h>

class CStatistics {
private:
	unsigned int m_nCollision;
	unsigned int m_nCrossOver;
	unsigned int m_nMutation;

	static CStatistics* m_pInstance;

	CStatistics()
	{
		Reset();
	}
	CStatistics( const CStatistics& Other )
	{
	}
	CStatistics& operator = (CStatistics &Other)
	{
	}
public:
	static CStatistics* Get()
	{
		if(!m_pInstance){
			m_pInstance = new CStatistics();			
		}
		return m_pInstance;
	}
	
	void Release()
	{
		if(m_pInstance) 
			delete m_pInstance;
	}

	void Reset()
	{
		m_nCollision = 0;
		m_nCrossOver = 0;
		m_nMutation  = 0;
	}

	void AddCollision(unsigned int n)
	{
		m_nCollision += n;
	}

	void AddCrossOver(unsigned int n)
	{
		m_nCrossOver += n;
	}

	void AddMutation(unsigned int n)
	{
		m_nMutation += n;
	}

	void PrintStats()
	{
		printf("====== Statistics ==========\n");
		printf("Total collision test performed:\t\t%lu\n",m_nCollision);
		printf("Total crossover performed:\t\t%lu\n",m_nCrossOver);
		printf("Total mutation performed:\t\t%lu\n",m_nMutation);
		printf("----------------------------\n");
	}
};


#endif

