/************************************************************
	
	mgDef.h
	-------------
	Author: Zahid

	Desc  : Defines common data types 

	This is a sole property of Mirage project 

*************************************************************/

#ifndef __MGDEF_H__
#define __MGDEF_H__

typedef unsigned short  mgWord_t;
typedef unsigned long  mgDWord_t;
typedef char            mgByte_t;
typedef unsigned char  mgUByte_t;

//#####################################
#ifdef MG_DOUBLE
	typedef double           mgReal_t;
#else
	typedef float		     mgReal_t;
#	ifndef MG_FLOAT
#		define MG_FLOAT
#	endif
#endif
//#####################################

#define PI     3.1415926535897932384626433832795
#define TWOPI  6.283185307179586476925286766559
#define FOURPI 12.566370614359172953850573533118
#define INVPI  0.31830988618379067153776752674503
#define PIBY2  1.5707963267948966192313216916398
#define PIBY3  1.0471975511965977461542144610932
#define PIBY4  0.78539816339744830961566084581988

#define INV180 0.0055555555555555555555555555555556
#define INV360 0.0027777777777777777777777777777778

#define TORAD(d) ((d)  * 0.017453292519943295769236907684886)
#define TODEG(r) ((r)  * 57.295779513082320876798154814105)

#define MG_TRUE  -1
#define MG_FALSE  0

#define RANDDOUBLE(r)  (((double)rand()/(double)RAND_MAX)*(r))
#define RANDFLOAT(r)   (((float)rand()/(float)RAND_MAX)*(r))
#define RANDRANGE(a,b) (RANDFLOAT(((b) - (a))) + (a))

#ifndef NULL
#define NULL 0
#endif

#define EPSILON 5E-4
#define ABS(x) ((x) < 0 ? -(x):(x))
#define SIGN(x) ((x)<0 ? -1.0f : 1.0f)

#ifdef  MG_DLL
#	define MG_DLLAPI __declspec( dllexport )
#else
#	define MG_DLLAPI
#endif


#endif

